#!/usr/bin/ruby

require "rexml/document"

# usbmodules= "/tmp/usb_modules.xml"
usbmodules = "/etc/lesslinux/usb_modules.xml"

xdoc = REXML::Document.new(File.new(usbmodules))

modids = Array.new
vendors = Hash.new

xdoc.elements.each("deviceids/usbmodule") { |m|
	# puts m.attributes["module"]
	m.elements.each("dev") { |d|
		# puts "   " + d.attributes["vendor"] + " " + d.attributes["id"]
		unless vendors.has_key?(d.attributes["vendor"])
			vendors[d.attributes["vendor"]] = Hash.new
		end
		unless vendors[d.attributes["vendor"]].has_key?(d.attributes["id"])
			 vendors[d.attributes["vendor"]][d.attributes["id"]] = Array.new
		end
		vendors[d.attributes["vendor"]][d.attributes["id"]].push(m.attributes["module"])
		vendors[d.attributes["vendor"]][d.attributes["id"]].uniq!
	}
}

#vendors.each_key { |k|
#	# puts k
#	vendors[k].each_key { |d|
#		# puts "   " + d  +": " + vendors[k][d].join(" ")
#	}
#}

IO.popen("lsusb") { |l|
	while l.gets
		toks = $_.split
		v = toks[5].split(":")[0]
		i = toks[5].split(":")[1]
		begin
			puts v + ":" + i + " loading: " + vendors[v.to_i(16).to_s(16)][i.to_i(16).to_s(16)].join(" ")
			vendors[v.to_i(16).to_s(16)][i.to_i(16).to_s(16)].each { |m|
				system("modprobe -v " + m)
			}
		rescue
		end
	end
}
